use std::fs;
use std::io::Write;

use scraper;
use tokio::time;

#[tokio::main]
async fn main()
{
    for title in ["test", "yiy"]
    {
        download_images_async(title).await;
    }
}

async fn download_images_async(title : &str)
{
    let root_url : &str = "https://uta.pw/shodou";

    let url : String = format!
    (
        "{}/index.php?titles&show&title={}",
        root_url,
        urlencoding::encode(title)
    );

    println!("GET : {}", url);

    let html_string : String = reqwest::get(url).await.unwrap().text().await.unwrap();

    let html : scraper::Html = scraper::Html::parse_document(&html_string);

    let selector : scraper::Selector = scraper::Selector::parse(".articles img").unwrap();

    for(index, element) in html.select(&selector).enumerate()
    {
        let source : &str = element.value().attr("src").unwrap();

        let img_url : String = format!("{}/{}", root_url, source);

        println!("{}", img_url);

        let file_name : String = format!("{}_{}.png", title, index);

        let bytes = reqwest::get(img_url).await.unwrap().bytes().await.unwrap();

        let mut file : fs::File = fs::File::create(file_name).unwrap();

        file.write_all(&bytes).unwrap();

        time::sleep(time::Duration::from_millis(1000)).await;
    }
}